﻿EnableExplicit

Procedure Gauge_Analog_Round(gid, value.f,  min_value.f = -50, max_value.f = 50, units.s = "", dialcolor = 0, pointercolor = 0, colorvalue = 0, angle_start = -100, small_step = 4, big_step = 20, valuefontsize.f = 0, dialfontsize.f = 0, unitsfontsize.f = 0, bgcolor = 0)
  Protected.f angle_end, resolution_of_gauge, resolution_of_value, outval, y
  Protected.f steps_small_gauge, steps_big_gauge, out_text_width, out_text_height, out_units_height, out_units_width
  Protected.i loop_step
  Protected.s out$, out_units$
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())
    AddPathBox(0, 0, GadgetWidth(gid), GadgetWidth(gid))
    If bgcolor = 0 : VectorSourceColor(RGBA(255,255,255,255)) : Else : VectorSourceColor(bgcolor) : EndIf
    FillPath()
    
    angle_end = Abs(angle_start)
    resolution_of_gauge = Abs(angle_start - angle_end)
    steps_small_gauge = resolution_of_gauge/small_step
    steps_big_gauge= resolution_of_gauge/big_step
    
    If max_value < 0 And  min_value  < 0
      resolution_of_value  =  Abs(max_value -  min_value)
    ElseIf max_value >= 0 And min_value  < 0
      resolution_of_value  = max_value + Abs(min_value)
    Else
      resolution_of_value = max_value - min_value
    EndIf
    
    ;dial
    BeginVectorLayer(200)
    If dialfontsize = 0 : dialfontsize = GadgetHeight(gid)/20 : EndIf
    VectorFont(FontID(0),dialfontsize)
    If dialcolor = 0 : dialcolor = (RGBA(0,0,0,255)) : EndIf
    VectorSourceColor(dialcolor)
    
    RotateCoordinates(GadgetWidth(gid)/2, GadgetWidth(gid)/2,(loop_step * small_step) + angle_start)
    loop_step = 0
    While loop_step <= steps_small_gauge
      MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/5)
      If Mod(loop_step * small_step, big_step) <> 0
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/7)
        StrokePath(GadgetWidth(gid)/200,#PB_Path_RoundEnd)
      Else
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/8)
        StrokePath(GadgetWidth(gid)/100,#PB_Path_RoundEnd)
        outval.f = (((loop_step* small_step)/resolution_of_gauge) * resolution_of_value) + min_value
        out$ = StrF(outval)
        SaveVectorState()
        RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/20, angle_end - (loop_step * small_step) )
        MovePathCursor(GadgetWidth(gid)/2-VectorTextWidth(out$ )/2, GadgetHeight(gid)/20-VectorTextHeight(out$)/2)
        DrawVectorText(out$)
        RestoreVectorState()
      EndIf
      RotateCoordinates(GadgetWidth(gid)/2, GadgetWidth(gid)/2,small_step)
      loop_step = loop_step + 1
    Wend
    EndVectorLayer()
    
    ;value
      BeginVectorLayer(200)
      If colorvalue= 0 : VectorSourceColor(RGBA(0,0,0,255)) : Else : VectorSourceColor(colorvalue) : EndIf
      
      If valuefontsize = 0 : valuefontsize = GadgetHeight(gid)/5 : EndIf   
      VectorFont(FontID(0), valuefontsize)
      out$ = StrF(value,2)
      out_text_width = VectorTextWidth(out$)
      out_text_height =  VectorTextHeight(" ", #PB_VectorText_Baseline)
      
      If unitsfontsize = 0 : unitsfontsize = GadgetHeight(gid)/8: EndIf  
      VectorFont(FontID(0), unitsfontsize)
      out_units$ = units
      out_units_width = VectorTextWidth(out_units$)
      out_units_height = VectorTextHeight(" ", #PB_VectorText_Baseline)
      
      y = 0.9*(GadgetHeight(gid)) - out_text_height
      MovePathCursor((GadgetWidth(gid)/2) - ((out_text_width + out_units_width)/2), y)
      VectorFont(FontID(0), valuefontsize)
      DrawVectorText(out$)
      
      
      VectorFont(FontID(0), unitsfontsize)
      y = 0.9*(GadgetHeight(gid)) - out_units_height
      MovePathCursor((GadgetWidth(gid)/2) - (out_text_width+out_units_width)/2 + out_text_width, y)
      DrawVectorText(out_units$)
      
      EndVectorLayer()
    
    ;pointer
    BeginVectorLayer(230)
    If pointercolor = 0 : pointercolor = RGBA(255,0,0,255) : EndIf
    VectorSourceColor(pointercolor)
    MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/2)
    RotateCoordinates(GadgetWidth(gid)/2, GadgetWidth(gid)/2,((value/resolution_of_value) * resolution_of_gauge) + angle_start)
    AddPathLine(GadgetWidth(gid)/2.05, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2, GadgetHeight(gid)/7)
    AddPathLine(GadgetWidth(gid)/1.95, GadgetHeight(gid)/2)
    FillPath()
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/40)
    FillPath()
    EndVectorLayer()
    StopVectorDrawing()
  EndIf
EndProcedure

Procedure Resize_Window()
  ResizeGadget(11, 0, 0, WindowHeight(0), WindowHeight(0))
  Gauge_Analog_Round(11,Random(2000.0)/100,0,20,"V")
  
    ResizeGadget(12, WindowHeight(0), 0, WindowHeight(0), WindowHeight(0))
  Gauge_Analog_Round(12,Random(10000.0)/100,0,100,"mA",RGBA(0,0,255,255),RGBA(0,150,0,255), RGBA(255,150,0,255),-120,4,24,0,0,0,RGBA(200,255,255,255))
EndProcedure

Procedure StartProgram()
  Protected Event, position.f
  If OpenWindow(0, 0, 0, 400, 200, "Round Analog Gauge", #PB_Window_SystemMenu | #PB_Window_SizeGadget| #PB_Window_MaximizeGadget) 
    AddWindowTimer(0, 123,500)
    LoadFont(0, "Ubuntu", 20,  #PB_Font_HighQuality)
    CanvasGadget(11, 0, 0, 0, 0)
     CanvasGadget(12, 0, 0, 0, 0)
    BindEvent(#PB_Event_SizeWindow, @Resize_Window(), 0)
    BindEvent(#PB_Event_Timer, @Resize_Window(), 0)
    Resize_Window()
    Repeat
      Event = WaitWindowEvent()
    Until Event = #PB_Event_CloseWindow
  EndIf 
EndProcedure

StartProgram()
; IDE Options = PureBasic 5.72 (Linux - x64)
; CursorPosition = 108
; FirstLine = 83
; Folding = -
; EnableXP